/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM
 * e:/builds/moz2_slave/mozilla-1.9.1-win32-xulrunner/build/dom/public/idl/events/nsIDOMDataTransfer.idl
 */

package org.mozilla.interfaces;

public interface nsIDOMNSDataTransfer extends nsISupports {

  String NS_IDOMNSDATATRANSFER_IID =
    "{53c854fc-33f9-4647-b045-46d7ab06a6f1}";

  /**
   * The number of items being dragged.
   */
  long getMozItemCount();

  /**
   * Holds a list of the format types of the data that is stored for an item
   * at the specified index. If the index is not in the range from 0 to
   * itemCount - 1, an empty string list is returned.
   */
  nsIDOMDOMStringList mozTypesAt(long index);

  /**
   * Remove the data associated with the given format for an item at the
   * specified index. The index is in the range from zero to itemCount - 1.
   *
   * If the last format for the item is removed, the entire item is removed,
   * reducing the itemCount by one.
   *
   * If format is empty, then the data associated with all formats is removed.
   * If the format is not found, then this method has no effect.
   *
   * @param format the format to remove
   * @throws NS_ERROR_DOM_INDEX_SIZE_ERR if index is greater or equal than itemCount
   * @throws NO_MODIFICATION_ALLOWED_ERR if the item cannot be modified
   */
  void mozClearDataAt(String format, long index);

  void mozSetDataAt(String format, nsIVariant data, long index);

  /**
   * Retrieve the data associated with the given format for an item at the
   * specified index, or null if it does not exist. The index should be in the
   * range from zero to itemCount - 1.
   *
   * @param format the format of the data to look up
   * @returns the data of the given format, or null if it doesn't exist.
   * @throws NS_ERROR_DOM_INDEX_SIZE_ERR if index is greater or equal than itemCount
   */
  nsIVariant mozGetDataAt(String format, long index);

  /**
   * Will be true if the user cancelled the drag (typically by pressing Escape).
   * This will be false otherwise, including if a drag failed for any other reason.
   * This property is only relevant for the dragend event.
   */
  boolean getMozUserCancelled();

}